SystemOrganization addCategory: #'Mason-MC2'!

MDWriteScriptJob subclass: #MDFileoutSnapshotsJob
	instanceVariableNames: 'store references'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mason-MC2'!

!MDFileoutSnapshotsJob methodsFor: 'accessing' stamp: 'cwp 12/31/2008 11:23'!
addRepository: aRepository 
	(store repositories includes: aRepository) ifFalse: 
		[ store addRepository: aRepository ].! !

!MDFileoutSnapshotsJob methodsFor: 'accessing' stamp: 'cwp 12/31/2008 11:36'!
addSnapshotReference: aHashstamp 
	references add: aHashstamp! !

!MDFileoutSnapshotsJob methodsFor: 'accessing' stamp: 'cwp 12/31/2008 11:39'!
addSnapshotTarget: aTarget 
	self addRepository: aTarget repository.
	self addSnapshotReference: aTarget snapshotReference! !

!MDFileoutSnapshotsJob methodsFor: 'initialize-release' stamp: 'cwp 12/31/2008 11:33'!
initialize
	super initialize.
	store := MDStore new.
	references := Set new! !

!MDFileoutSnapshotsJob methodsFor: 'accessing' stamp: 'cwp 12/31/2008 11:12'!
repository
	^ store! !

!MDFileoutSnapshotsJob methodsFor: 'running' stamp: 'cwp 12/31/2008 12:27'!
run
	super run.
	store repositories do: [:ea | ea close]! !

!MDFileoutSnapshotsJob methodsFor: 'accessing' stamp: 'cwp 12/31/2008 11:36'!
snapshots
	^ references collect: [:ea | store get: ea]! !

!MDFileoutSnapshotsJob methodsFor: 'running' stamp: 'cwp 12/31/2008 12:27'!
writeOn: stream 
	| exporter |
	exporter := MDFileOutExporter on: stream.
	self snapshots do: 
		[ :snapshot | 
		(snapshot getVersionsFrom: store) do: 
			[:version | exporter addVersion: version]].
	exporter harmonize.
	exporter flush! !

!MDTargetCanvas methodsFor: '*mason-mc2-targets' stamp: 'cwp 7/12/2009 00:43'!
latest
	^ self addChild: MDLatestSnapshotTarget new ! !

MDTarget subclass: #MDLatestSnapshotTarget
	instanceVariableNames: 'repositoryPath sliceName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mason-MC2'!

!MDLatestSnapshotTarget methodsFor: 'jobs' stamp: 'cwp 12/31/2008 11:31'!
addJobToQueue: jobs path: aPath name: aString
	| path job |
	path := self scriptPathIn: aPath basename: aString ordinal: jobs size + 1.
	job := MDFileoutSnapshotsJob new
		path: path;
		addSnapshotTarget: self;
		yourself.
	jobs add: job! !

!MDLatestSnapshotTarget methodsFor: 'testing' stamp: 'cwp 12/31/2008 12:03'!
memoMatches: aMemo
	^ aMemo sliceName = sliceName! !

!MDLatestSnapshotTarget methodsFor: 'jobs' stamp: 'cwp 12/23/2008 12:04'!
queueJobsIn: jobs build: aBuild name: aString
	(jobs isEmpty or: [jobs last class ~= MDFileoutSnapshotsJob])
		ifTrue: [self addJobToQueue: jobs path: aBuild temporaryDirectory name: aString]
		ifFalse: [jobs last addSnapshotTarget: self]
	! !

!MDLatestSnapshotTarget methodsFor: 'jobs' stamp: 'cwp 12/31/2008 12:13'!
repository
	^ MDFileRepository on: self repositoryStream! !

!MDLatestSnapshotTarget methodsFor: 'jobs' stamp: 'cwp 12/31/2008 12:13'!
repositoryDo: aBlock
	^ MDFileRepository
		on: self repositoryStream
		do: aBlock! !

!MDLatestSnapshotTarget methodsFor: 'jobs' stamp: 'cwp 12/31/2008 12:13'!
repositoryStream
	^ FileStream oldFileNamed: repositoryPath asString! !

!MDLatestSnapshotTarget methodsFor: 'accessing' stamp: 'cwp 12/31/2008 12:00'!
sliceName: aString
	sliceName := aString! !

!MDLatestSnapshotTarget methodsFor: 'jobs' stamp: 'cwp 12/31/2008 12:05'!
snapshotReference
	| memos latest |
	memos := self repositoryDo:
		[:repository |
		repository memos select: [:ea | self memoMatches: ea]].
	latest := memos
		inject: memos anyOne
		into: 
			[:memo :each |
			(each <= memo)
				ifTrue: [memo]
				ifFalse: [each]].
	^ latest reference! !
